<template lang="pug">
Box(:title="$t('page.profile.staking.my_stakes.title')")
  Table(:columns="columns", :data="stakes" @click='handleButtonClick')
    template(v-slot:id="{ item }") \#{{ item.id }}
    template(v-slot:staked="{ item }") 
      p.has-text-success.has-text-weight-bold {{ item.staked }} IBT
    template(v-slot:date="{ item }") {{ dayjs(item.date).format('DD/MM/YYYY') }}
    template( #button ) {{ $t('page.profile.staking.my_stakes.withdraw') }}
  .wrap
    buttons
      b-button(type="yellow", fullwidth, @click="claim") {{ $t('buttons.withdraw_all') }}
</template>

<script lang="ts">
import dayjs from "dayjs";
import Vue from "vue";
import Component from "vue-class-component";
import { VModel, Prop, Watch } from "vue-property-decorator";
import { BigNumber } from "bignumber.js";
import { UserModule } from "./../../store/module/UserModule";
import { Web3Module } from "./../../store/module/Web3Module";
import { Contract } from "web3-eth-contract";
import { PoolModule } from "../../store/module/PoolModule";
import { Stake } from "../../store/module/sharedTypes";
import Web3 from "web3";

export type StakeItem = {
  id: number;
  staked: string;
  date: Date;
};

@Component({
  components: {
    Box: () => import("../Box.vue"),
    Table: () => import("../Table.vue"),
  },
})
export default class MyStakes extends Vue {
  dayjs = dayjs;

  stakes: StakeItem[] = [];

  get columns() {
    return [
      {
        field: "id",
        label: this.$t("page.profile.staking.my_stakes.num"),
      },
      {
        field: "staked",
        label: this.$t("page.profile.staking.my_stakes.staked"),
      },
      {
        field: "date",
        label: this.$t("page.profile.staking.my_stakes.date"),
      },
    ];
  }

  get account() {
    return this.$store.getters["Web3Module/account"];
  }

  get user(): UserModule.User {
    return this.$store.getters["UserModule/user"];
  }

  get memePool(): PoolModule.Pool {
    return this.$store.getters["PoolModule/memePool"];
  }

  @Watch("user")
  onUserChange() {
    this.load();
  }

  @Watch("memePool")
  onPoolChange() {
    this.load();
  }

  click() {
    console.log("click")
  }

  handleButtonClick(item) {
    this.claim(item.id)
  }

  async claim(id: number = -1) {
    console.log(this.memePool);
    if (this.memePool.id === 0) return;
    const pool: Contract = await this.$store.dispatch(
      "Web3Module/getPoolInstance",
      this.memePool.address
    );

    try {
      if (id > 0) {
        await pool.methods.claimFromStake(id - 1).send({
          from: this.account,
        });
      } else {
        await pool.methods.claim().send({
          from: this.account,
        });
      }
      this.$notify({
        title: "Claimed succefully",
        type: "success",
      });
    } catch (e: any) {
      return this.$notify({
        title: "Error while claiming",
        text: (e as any).message,
        type: "error",
      });
    }
  }

  async load() {
    if (!this.user?.address) return;
    if (this.memePool.id === 0) return;
    this.stakes.splice(0);

    this.user?.stakes
      ?.filter((stake) => stake.poolId === this.memePool.id)
      .sort((a, b) => {
        return (
          new Date(a.createdAt).getTime() - new Date(b.createdAt).getTime()
        );
      })
      .map((stake) => {
        this.stakes.push({
          id: stake.stakeIndex + 1,
          staked: new BigNumber(stake.body).dividedBy(10 ** 18).toString(),
          date: dayjs(stake.expiresIn).toDate(),
        });
      });
  }

  mounted() {
    this.load();
  }
}
</script>

<style lang="scss" scoped>
.wrap {
  margin-top: 2rem;
}
</style>